filltypemovers = {};

--needs module filltypemovers
--lineType 2/filltypemovers
function filltypemovers:load(filltypemoverName)
	local lineTable = {lineTyp=2, txtScroll={leftRight=true,upDown=true}};
	if moFillTypeMovers.values.factorys ~= nil and moFillTypeMovers.values.factorys[filltypemoverName] ~= nil then
		for factory=1, #moFillTypeMovers.values.factorys[filltypemoverName] do
			if moFillTypeMovers.values.factorys[filltypemoverName][factory] ~= nil then
				local filltypemoverGeneral = moFillTypeMovers.values.factorys[filltypemoverName][factory].general[1];
				lineTable[#lineTable+1] = {};
				local isLineTable = lineTable[#lineTable];
				
				if #moFillTypeMovers.values.factorys[filltypemoverName] > 1 and factory ~= 1 then					
					isLineTable.setLineBorderNewObject = true;	
				end;
				
				isLineTable.lineClickHelp = true;
				isLineTable.lineClickHelpCallback = filltypemovers.returnLineHelpIconClick
				isLineTable.helpTxt = "Click Factory(FM)/FactoryName/%/FillLevel or .... ++ for more info (or MapHotSpot)";
				
				local color = 1;				
				isLineTable.ownValues = {filltypemoverName};
				isLineTable.txt = {};			
				isLineTable.txt[1] = {};			
				isLineTable.txt[1].nodeId = filltypemoverGeneral.object.nodeId;
				--isLineTable.txt[1].width = 80;	--width prozent	
				isLineTable.txt[1].color = moColors:getColor(moModule.values.txtTitleColor);
				isLineTable.txt[1].bold = true;			
				local isNearObject = moModule:nearPlayerPosition(filltypemoverGeneral.object, 20);				
				if isNearObject ~= nil then	isLineTable.txt[1].clickCallback = filltypemovers.returnClickObjectName;end;				
				if isNearObject ~= nil and isNearObject then
					isLineTable.txt[1].txt = ">>".. filltypemoverGeneral.objectName.. "<<";
				else
					isLineTable.txt[1].txt = filltypemoverGeneral.objectName;
				end;
				isLineTable.txt[1].txtPos = 1;
				--productivity
				if filltypemoverGeneral.productivityObject ~= nil and filltypemoverGeneral.productivityObject then
					lineTable[#lineTable+1] = {};
					isLineTable = lineTable[#lineTable];				
					isLineTable.ownValues = {filltypemoverName};
					isLineTable.txt = {};			
					isLineTable.txt[1] = {};			
					isLineTable.txt[1].width = 80;	--width prozent	
					color = Utils.getNoNil(moColors.prozent[filltypemoverGeneral.productivityColor], 1);
					isLineTable.txt[1].color = moColors:getColor(color, nil, moModule.values.txtColor);
					isLineTable.txt[1].bold = moModule.values.txtBold;
					isLineTable.txt[1].txt = filltypemoverGeneral.productivityName;
					isLineTable.txt[2] = {};			
					isLineTable.txt[2].width = 20;	--width prozent	
					isLineTable.txt[2].color = moColors:getColor(color, nil, moModule.values.txtColor);
					isLineTable.txt[2].bold = moModule.values.txtBold;
					isLineTable.txt[2].txt = filltypemoverGeneral.productivity.. "%";
					isLineTable.txt[2].txtPos = 2;
				end;
				--productivity
				--output
				local filltypemoverOutput = moFillTypeMovers.values.factorys[filltypemoverName][factory].output;
				if filltypemoverOutput ~= nil and #filltypemoverOutput > 0 then
					for output=1, #filltypemoverOutput do
						local outputTable = filltypemoverOutput[output];
						lineTable[#lineTable+1] = {};
						isLineTable = lineTable[#lineTable];				
						isLineTable.ownValues = {filltypemoverName};
						isLineTable.txt = {};			
						isLineTable.txt[1] = {};			
						isLineTable.txt[1].width = 80;	--width prozent
						isLineTable.txt[1].color = moColors:getColor(moModule.values.txtColor)
						isLineTable.txt[1].bold = moModule.values.txtBold;
						isLineTable.txt[1].txt = outputTable.fillTypeName;
						isLineTable.txt[2] = {};			
						isLineTable.txt[2].width = 20;	--width prozent
						isLineTable.txt[2].color = moColors:getColor(moModule.values.txtColor)
						isLineTable.txt[2].bold = moModule.values.txtBold;						
						isLineTable.txt[2].txt = outputTable.fillLevel;
						isLineTable.txt[2].clickCallback = filltypemovers.returnClickFillLevelCapacityTotal;
						isLineTable.txt[2].ownValues = {tostring(outputTable.capacity), tostring(outputTable.percentageCapacity), true};
						isLineTable.txt[2].txtPos = 2;
					end;	
				end;
				--output
				--input
				if filltypemoverGeneral.productivityObject ~= nil and filltypemoverGeneral.productivityObject then
					local filltypemoverInput = moFillTypeMovers.values.factorys[filltypemoverName][factory].input;
					if filltypemoverInput ~= nil and #filltypemoverInput > 0 then
						if #filltypemoverInput > 0 then
							isLineTable.txt[1].lineBorder = {6, 0.0005, false, true, false, false, moColors.intern["darkGray"], 0};
							isLineTable.txt[2].lineBorder = {6, 0.0005, false, true, false, false, moColors.intern["darkGray"], 2};
						end;
						for input=1, #filltypemoverInput do
							local inputTable = filltypemoverInput[input];
							lineTable[#lineTable+1] = {};
							isLineTable = lineTable[#lineTable];				
							isLineTable.ownValues = {filltypemoverName};
							isLineTable.txt = {};						
							isLineTable.txt[1] = {};			
							isLineTable.txt[1].width = 80;	--width prozent
							isLineTable.txt[1].color = moColors:getColor(moModule.values.txtColor)
							isLineTable.txt[1].bold = moModule.values.txtBold;
							if inputTable.fillTypesTotal ~= nil and #inputTable.fillTypesTotal > 1 then
								isLineTable.txt[1].txt = inputTable.fillTypeName.. " ++";
								isLineTable.txt[1].fillTypesTotal = inputTable.fillTypesTotal;
								isLineTable.txt[1].clickCallback = filltypemovers.returnClickFillTypesTotal;							
							else
								isLineTable.txt[1].txt = inputTable.fillTypeName;
							end;
							isLineTable.txt[2] = {};			
							isLineTable.txt[2].width = 20;	--width prozent
							isLineTable.txt[2].color = moColors:getColor(moModule.values.txtColor)
							isLineTable.txt[2].bold = moModule.values.txtBold;						
							isLineTable.txt[2].txt = tostring(inputTable.percentageCapacity).. "%";							
							isLineTable.txt[2].clickCallback = filltypemovers.returnClickFillLevelCapacityTotal;
							isLineTable.txt[2].ownValues = {tostring(inputTable.capacity), tostring(inputTable.fillLevel)};
							isLineTable.txt[2].txtPos = 2;
						end;
					end;
				end;
				--input
			end;
		end;	
	end;
	filltypemovers[filltypemoverName] = {output=lineTable};
end;

function filltypemovers.returnClickFillLevelCapacityTotal(...)
	if ... ~= nil then
		local args = ...;		
		if args.line ~= nil and args.ownValues ~= nil and args.ownValues[1] ~= nil then			
			local capacity = filltypemovers[args.ownValues[1]].output[args.line].txt[2].ownValues[1];
			local fillLevel = filltypemovers[args.ownValues[1]].output[args.line].txt[2].ownValues[2];
			local flipFillLevel = filltypemovers[args.ownValues[1]].output[args.line].txt[2].ownValues[3];
			--if string.len(capacity) > 0 then				
				moSetGetOverlays.infoHelpBox.info.lsTimer = -1;
				local capacityLanguage = moLanguageXml:getTxt("capacity", nil, "Capacity:");
				local fillcontainerLanguage = moLanguageXml:getTxt("fillcontainer", nil, "Foodtrough:");
				local prozent = ""
				if flipFillLevel ~= nil then prozent = "%";end;				
				moSetGetOverlays.infoHelpBox.info.txt = tostring(capacityLanguage).. " ".. tostring(capacity).. "\n".. tostring(fillcontainerLanguage).. " ".. tostring(fillLevel).. tostring(prozent);				
			--end;
		end;
	end;
end;

function filltypemovers.returnClickFillTypesTotal(...)
	if ... ~= nil then
		local args = ...;
		if args.line ~= nil and args.position ~= nil and args.ownValues ~= nil and args.ownValues[1] ~= nil then
			local fillTypesTotal = filltypemovers[args.ownValues[1]].output[args.line].txt[1].fillTypesTotal;
			local fillTypeNamen = "";			
			for _, fillType in pairs (fillTypesTotal) do				
				local fillTypes = moFillTypes.values.fillTypes[fillType];
				if fillTypes ~= nil then
					fillTypeNamen = fillTypeNamen.. tostring(fillTypes.name).. " - ";
				end;										
			end;
			if string.len(fillTypeNamen) > 0 then
				moSetGetOverlays.infoHelpBox.info.lsTimer = -1;
				moSetGetOverlays.infoHelpBox.info.txt = tostring(fillTypeNamen);	
			end;
		end;
	end;
end;

function filltypemovers.returnLineHelpIconClick(...)	
	if ... ~= nil then		
		local args = ...;		
		if args.line ~= nil and args.ownValues ~= nil and args.ownValues[1] ~= nil then
			moSetGetOverlays.infoHelpBox.help.lsTimer = -1;
			moSetGetOverlays.infoHelpBox.help.txt = tostring(filltypemovers[args.ownValues[1]].output[args.line].helpTxt);
		end;
	end;
end;

function filltypemovers.returnClickObjectName(...)
	if ... ~= nil then		
		local args = ...;
		if args.line ~= nil and args.ownValues ~= nil and args.ownValues[1] ~= nil then
			local filltypemoverName = args.ownValues[1];
			if filltypemovers[filltypemoverName] ~= nil and filltypemovers[filltypemoverName].output ~= nil and filltypemovers[filltypemoverName].output[args.line] ~= nil then
				local nodeId = filltypemovers[filltypemoverName].output[args.line].txt[1].nodeId;
				local x, _, z = getWorldTranslation(nodeId);
				moSetGetOverlays:mapHotSpot(nil, x, z);
			end;
		end;		
	end;
end;

function filltypemovers.giveOutputTable(...)	
	if ... ~= nil then
		local args = ...;
		moModule.active.filltypemovers.isRunning = true;moModule.active.filltypemovers.last = moModule.time.min+moModule.time.delay;
		if args.ownValues ~= nil and args.ownValues[1] ~= nil then
			local filltypemoverName = args.ownValues[1];
			filltypemovers:load(filltypemoverName);
			return filltypemovers[filltypemoverName].output;
		end;		
	end;
end;

function filltypemovers.reset(whichSLOT)
	if whichSLOT ~= nil and moSetGetOverlays.slot[whichSLOT] ~= nil then moSetGetOverlays.slot[whichSLOT].save = false;end;
	--filltypemovers:load();	
end;

function filltypemovers:generateCmd(filltypemoverName)
	local _, errorTable = 0, {};
	function insertCmd(filltypemoverName, objectsNodes, objectsIds)
		local newCmdTable = { insert=true, cmdOldTable=MultiOverlayV3.moduleCmdTable, cmdTable = {} };	
		local filltypemoverNameTemp = tostring(filltypemoverName):lower();
		local languageName = moLanguageXml:getTxt(filltypemoverNameTemp, nil, filltypemoverName);
		newCmdTable.cmdTable[1] = {
			cmdName = "filltypemovers_".. tostring(filltypemoverName);
			displayName = moLanguageXml:getTxt("filltypemovers", nil, "Factory(FM)").. " ".. tostring(languageName);		
			multiple = true;
			sortBy = "Factory(FM)";
			infoTxt = "Zeigt alle FillTypeMovers oder diese Category an (".. tostring(languageName).. ")";
			helpTxt = "View FillTypeMovers(Factory) or Category";
			click = {mouseButtonLeft=true, mouseButtonMiddle=true, mouseButtonRight=true, key=true};
			lineTyp = 2;
			typ = "output";
			action = filltypemovers.giveOutputTable; --a function
			ownValues = {filltypemoverName, objectsNodes, objectsIds}; 
		};	
		_, errorTable = moSetGetCmd:generateNewCmd(newCmdTable);
		local errorPrint = false;
		if errorPrint and #errorTable > 0 then
			for a=1, #errorTable do
				print("! ERROR ! MultiOverlayV3 Hud -->cmd generate filltypemovers Cmd error ".. tostring(a).. ": ".. tostring(errorTable[a]))
			end;
		end;
	end;
	if filltypemoverName ~= nil then 
		local isAlreadyExits = moSetGetCmd:cmdFromReady(nil, "filltypemovers_".. filltypemoverName, "multioverlayV3Module", tostring(MultiOverlayV3.metadata.title), true, MultiOverlayV3.moduleCmdTable);
		if isAlreadyExits == nil then insertCmd(filltypemoverName);end;
	else		
		if moFillTypeMovers.values.factorys ~= nil then			
			for filltypemoverName, _ in pairs (moFillTypeMovers.values.factorys) do				
				local isAlreadyExits = moSetGetCmd:cmdFromReady(nil, "filltypemovers_".. filltypemoverName, "multioverlayV3Module", tostring(MultiOverlayV3.metadata.title), true, MultiOverlayV3.moduleCmdTable);
				if isAlreadyExits == nil then insertCmd(filltypemoverName, moModule:getObjectIds(moFillTypeMovers.values.factorys[filltypemoverName], false));end;
			end;
		end;
	end;	
end;